aboutsummaryrefslogtreecommitdiffstatshomepage
path: root/test
diff options
context:
space:
mode:
authorEgor Tensin <Egor.Tensin@gmail.com>2020-08-31 15:04:16 +0300
committerEgor Tensin <Egor.Tensin@gmail.com>2020-08-31 15:19:11 +0300
commit47119e285dfb4f2486a471f9b8c8714952acefea (patch)
tree0abb56f6e3a81420b218ade7df05606b21f67dc2 /test
parentTravis: stress_test.sh: prepare to move to test/ (diff)
downloadmath-server-47119e285dfb4f2486a471f9b8c8714952acefea.tar.gz
math-server-47119e285dfb4f2486a471f9b8c8714952acefea.zip
stress_test.sh: move to test/
Diffstat (limited to 'test')
-rwxr-xr-xtest/stress_test.sh75
1 files changed, 75 insertions, 0 deletions
diff --git a/test/stress_test.sh b/test/stress_test.sh
new file mode 100755
index 0000000..ceac401
--- /dev/null
+++ b/test/stress_test.sh
@@ -0,0 +1,75 @@
+#!/usr/bin/env bash
+
+# Copyright (c) 2020 Egor Tensin <Egor.Tensin@gmail.com>
+# This file is part of the "math-server" project.
+# For details, see https://github.com/egor-tensin/math-server.
+# Distributed under the MIT License.
+
+set -o errexit -o nounset -o pipefail
+
+script_name="$( basename -- "${BASH_SOURCE[0]}" )"
+readonly script_name
+script_dir="$( dirname -- "${BASH_SOURCE[0]}" )"
+script_dir="$( cd -- "$script_dir" && pwd )"
+readonly script_dir
+
+install_dir="$HOME/install"
+readonly server_path='bin/math-server'
+readonly client_path='bin/math-client'
+readonly stress_test_path="$script_dir/stress_test.py"
+readonly server_port=16666
+server_pid=
+
+dump() {
+ local msg
+ for msg; do
+ echo "$script_name: $msg"
+ done
+}
+
+kill_server() {
+ dump "Killing the server with PID $server_pid..."
+ kill "$server_pid"
+ dump "Waiting for the server to terminate..."
+ wait "$server_pid"
+ dump "Done"
+}
+
+run_server() {
+ dump "Running the server..."
+ "$install_dir/$server_path" --port "$server_port" &
+ server_pid="$!"
+ dump "It's PID is $server_pid"
+ trap kill_server EXIT
+}
+
+run_stress_test() {
+ dump "Running stress_test.py..."
+ "$stress_test_path" \
+ --client "$install_dir/$client_path" \
+ --port "$server_port" \
+ --processes 4 \
+ --expressions 1000
+}
+
+script_usage() {
+ echo "usage: $script_name [INSTALL_DIR]"
+}
+
+parse_args() {
+ if [ "$#" -gt 1 ]; then
+ script_usage >&2
+ return 1
+ fi
+ if [ "$#" -gt 0 ]; then
+ install_dir="$1"
+ fi
+}
+
+main() {
+ parse_args "$@"
+ run_server
+ run_stress_test
+}
+
+main "$@"